#include <iostream.h>
#include <fstream.h>
#include <cstring>      //      ( )
#include <stdlib.h>
#include "c_Go.h"
#include "d_Loop.h"
#include "c_FEN.h"
#include "Iterative_Deepening.h"
//-----------------------------------------------------------------------------------
/*+
 *    
 *
 *  ChessTerminator75
 *   17.11.2007
 *
 *  
 *   
 *         d_Loop
*/
//	===================================================================


//	===================================================================
//    
// :  (),  (  )
void transformation_moves(char three_position[],T_PV * three_moves){
int i=0;//    
int n=0;//   6   
int k=0;//   

//    6 
//       

//      
  while (three_position[i] != '\0') { 
    i=i+1;
  }// while (three_position[i] != '\0') { 
// 01234567890123456789
// g1-f3 g8-f6 f3-g1 f6-g8 g1-f3 g8-f6
// 0  1  2  3  4  5  6 
//  6       
n= i-19;
//      
if (i<20) n=0;

//  (   )  
 for ( int q =0;q<5;q++){ 
   three_moves->initial_position[q]= q+1;
   three_moves->final_position[q]  = q+1;
   three_moves->Depth_Max =q;
  }//for ( q =0;q<7;q++){ 

//      (  )
  while ( n < i ) { 
   three_moves->initial_position[k]= 16*Ch_Koordinata_To_Indeks(three_position[n+1])+Koordinata_To_Indeks(three_position[n]);
   three_moves->final_position[k]  = 16*Ch_Koordinata_To_Indeks(three_position[n+3])+Koordinata_To_Indeks(three_position[n+2]);
   three_moves->Depth_Max =k;
   k=k+1;
   n=n+5;
  }//while ( n < i ) { 


}//void transformation_moves(char three_position[],T_PV three_moves){

//	*******************************************************************


//	===================================================================
//    
// : ,
void parse_three_position(char string_in[],char three_position[]){
 char * moves;
 char * ptr;
 int i;
//    moves
 moves = strstr(string_in,"moves ");
 if (moves != NULL) {
 //  moves 
 ptr = moves + 6;
  i=0;
  while (*ptr != '\0') { 
         three_position[i] = *ptr++;
		 i=i+1;
  }//while (*ptr != '\0') {
 }//if (moves != NULL) {

}//void parse_three_position(char string_in[],char three_position[]){
//	*******************************************************************


//	===================================================================
/*
    5   5 +    
> go btime 300000 wtime 300000 
for game in 5min. 
> go btime 302000 wtime 302000 winc 2000 binc 2000 
with incremental clock 5 min + 2 sec. 

    
> go movestogo 40 wtime 300000 btime 300000 
for 40 moves in 5 min. 
    
> go wtime 300000 btime 300000  movestogo 40

    
> go infinite 
for analysing. 

               
> go movetime 300000 
Exactly 5min for the next move, not supported by Fritz. 

*/

//   go    
//   > go depth 5 
// : ,,
void parse_go(char string_in[],char three_position[],T_board_list_816 * board_list_816,int & nodes){

char * ptr;
int depth = -1;
T_PV three_moves;//      
double wtime= -1.0;
double btime= -1.0; 
double winc= -1.0;
double binc= -1.0;
int movestogo= -1;
double movetime= -1.0; 
bool infinite= false;
int mate= -1 ;


//  strtok    
//            
//
ptr = strtok(string_in," "); //  "go"

//         
for (ptr = strtok(NULL," "); ptr != NULL; ptr = strtok(NULL," ")) {

   if (false) {

      } else if (string_equal(ptr,"depth")) {//
        ptr = strtok(NULL," ");
        depth = atoi(ptr);//  atoi     

      } else if (string_equal(ptr,"wtime")) {//    
		ptr = strtok(NULL," ");
        wtime = double(atoi(ptr)) / 1000.0;

      } else if (string_equal(ptr,"btime")) {//    
        ptr = strtok(NULL," ");
        btime = double(atoi(ptr)) / 1000.0;

      } else if (string_equal(ptr,"winc")) {//    
        ptr = strtok(NULL," ");
        winc = double(atoi(ptr)) / 1000.0;

      } else if (string_equal(ptr,"binc")) {//    
        ptr = strtok(NULL," ");
        binc = double(atoi(ptr)) / 1000.0;

      } else if (string_equal(ptr,"movestogo")) {//     
        ptr = strtok(NULL," ");
        movestogo = atoi(ptr);

      } else if (string_equal(ptr,"movetime")) {//   
        ptr = strtok(NULL," ");
        movetime = double(atoi(ptr)) / 1000.0;

      } else if (string_equal(ptr,"infinite")) {//  
        infinite = true;

//     ----------------------------------------------
//      } else if (string_equal(ptr,"mate")) {
//         ptr = strtok(NULL," ");
//         mate = atoi(ptr);
//      } else if (string_equal(ptr,"nodes")) {

//         ptr = strtok(NULL," ");
//         nodes = my_atoll(ptr);

//      } else if (string_equal(ptr,"ponder")) {
//         ponder = true;

//      } else if (string_equal(ptr,"searchmoves")) {
//-------------------------------------------------------------------

     }//   if (false) {

}//for (ptr = strtok(NULL," "); ptr != NULL; ptr = strtok(NULL," ")) {

//------------------------------------------------------------------------------

//        (     ) 
 transformation_moves(three_position,&three_moves);
nodes=0;
//      chess_board,Depth_Max
// Loop(board_list_816,depth,three_position,&three_moves,nodes);

//      chess_board,Depth_Max
 Deepening(board_list_816,depth,three_position,three_moves,nodes,wtime,btime,winc,binc,movestogo,movetime,infinite);

}//parse_go(char string_in[],int chess_board[]){
//	*******************************************************************

//	===================================================================
//      
static bool string_equal(const char s1[], const char s2[]) {
//       ?
   return strcmp(s1,s2) == 0;
}
//	*******************************************************************

//	===================================================================
//       
static bool string_start_with(const char s1[], const char s2[]) {
//         
//              
   return strstr(s1,s2) == s1;
}
//	*******************************************************************
